import java.applet.Applet;
import java.awt.*;

/*

  Date: January 6th, 1995

  Version: 1.0b1

  Description:
     This applet was coded to test out the ISO conversion routines
   in the ISO8859.java code. However, it also is a useful demo of
   the use of buttons and text edit fields.
     width and height in the <applet> HTML tag should always be 
   245 and 90 respectively.

  Coder: John Criswick, Ottawa, criswick@conveyor.com

  Copyright (c) 1996, John R. Criswick. All rights reserved.

*/

public class Entity extends Applet {
    ISO8859  theConverter;
    TextField  entryArea1;
    TextField  entryArea2;
    TextField  entryArea3;
    TextField  entryArea4;
    Button     toHTML;
    Button     toISO;

    /* TextFields are arranged like:

             1  3
             2  4
    */

    /* An about method in case I distribute this code in object form
      only (with a stub / header file). Programmers can call About
      in order to determine the version of this code etc.
    */
    public String About() {
      String aboutMe;

      aboutMe = new String("Entity Version 1.0b1 Jan.6.96 by John Criswick criswick@conveyor.com");
      return aboutMe;
    }

    /* Create the text fields and buttons. Default to a null layout since
      I want to have control over where I put these items in my applet.
    */
    public void init() {
      theConverter = new ISO8859();    // Class that handles conversions
      setLayout(null);

      toHTML = new Button("HTML ->");
      toHTML.setFont(new Font("Geneva", Font.PLAIN, 12));
      toHTML.reshape(95, 15, 55, 20);
      add(toHTML);

      toISO = new Button("ISO ->");
      toISO.setFont(new Font("Geneva", Font.PLAIN, 12));
      toISO.reshape(95, 55, 55, 20);
      add(toISO);

      entryArea1 = new TextField();
      entryArea1.reshape(10,10, 80, 30);
      add(entryArea1);

      entryArea2 = new TextField();
      entryArea2.reshape(10, 50, 80, 30);
      add(entryArea2);

      entryArea3 = new TextField();
      entryArea3.reshape(155,10, 80, 30);
      add(entryArea3);

      entryArea4 = new TextField();
      entryArea4.reshape(155,50, 80, 30);
      add(entryArea4);

    }

    /* All I do for the applet is draw a green frame around it. The
      buttons and text fields handle drawing themselves since they
      have been 'added' to this component.
    */
    public void paint(Graphics g) {
      Color  oldColour;

      oldColour = g.getColor();
      g.setColor(Color.green);
      g.drawRect(0, 0, bounds().width-1, bounds().height-1);

      g.setColor(oldColour);
    }

    /* When a user clicks a button this method is invoked (the mouse
      has been pressed and released within one of the buttons.
    */
    public synchronized boolean action(Event event, Object what) {
      if (event.target == toHTML) {
          Integer  theISO;
          String   theHTML;
          String   theEntry;

          /* Either its a number of the person entered a single character
            - respond to either or do nothing if neither.
          */
          theEntry = entryArea1.getText();

          /* Catch no characters entered first, otherwise this
            causes a string array index out of bounds exception
            when I try to look at charAt(0).
          */
          if (theEntry.length() == 0) {
            theHTML = new String("Nothing Entered");
          } else if (theEntry.length() == 1) {
            int  theNumber;

            /* Make sure when I convert from char to int that
              only the lower 8 bits get through
            */
            theNumber = (int) theEntry.charAt(0) & 0x00ff;
            theHTML = theConverter.ISOtoHTML(theNumber);
          } else if (Character.isDigit(theEntry.charAt(0))) {

            /* The user entered a number in the field so convert
              that to an HTML value.
            */
            theISO =  new Integer(entryArea1.getText());
            if ((theISO.intValue() > 255) || (theISO.intValue() < 0)) {
              theHTML = new String("Invalid Number");
            } else {
              theHTML = theConverter.ISOtoHTML(theISO.intValue());
            }
          } else {
            theHTML = new String("Invalid Entry");
          }
          entryArea3.setText(theHTML);
          return true;
      } else if(event.target == toISO) {
          String theHTML;
          int    theISO;
          char   theCharacter;

          theHTML = entryArea2.getText();
          theISO = theConverter.HTMLtoISO(theHTML);
          theCharacter = (char) theISO;
          entryArea4.setText(String.valueOf(theCharacter));
          return true;
      }

      return false;

    }

}

