import java.applet.*;
import java.awt.*;

/*
 * A simple rock, paper, scissors simulator.
 *
 * Jamie M. Hall, jamihall@mhv.net 12/95
 * 
 * Feel free to re-use any part of this code.
 */

public class Rocham extends Applet {

  Button rock, paper, scissors;
  Label computer, result, score;
  
  public void init() {
    setFont(new Font("Helvetica", Font.BOLD, 14));
    setBackground(Color.white);
    setLayout(new BorderLayout());

    Panel o = new Panel();
    o.setLayout(new FlowLayout());
    add("North", o);

    rock = new Button("Rock");
    rock.setBackground(Color.orange);
    o.add(rock);

    paper = new Button("Paper");
    paper.setBackground(Color.cyan);
    o.add(paper);

    scissors = new Button("Scissors");
    scissors.setBackground(Color.magenta);
    o.add(scissors);

    Panel p = new Panel();
    p.setLayout(new BorderLayout());
    add("Center", p);

    p.add("North", new Label());

    Panel q = new Panel();
    q.setLayout(new FlowLayout());
    p.add("Center", q);
    q.add(new Label("Computer:"));
    computer = new Label("               ");
    q.add(computer);

    Panel r = new Panel();
    r.setLayout(new FlowLayout());
    p.add("South", r);
    r.add(new Label("Result:"));
    result = new Label("               ");
    r.add(result);

    Panel s = new Panel();
    s.setLayout(new BorderLayout());
    add("South", s);

    s.add("North", new Label());

    Panel t = new Panel();
    t.setLayout(new FlowLayout());
    s.add("Center", t);
    t.add(new Label("Score:"));
    score = new Label("0  ");
    t.add(score);

  }

  public boolean action(Event evt, Object arg) {
    if (evt.target instanceof Button)
      doRound(((Button)evt.target).getLabel());
    return true;
  }

  public void doRound(String hand) {
    int compThrow, playerThrow;

    compThrow = (int) (Math.random() * 1000) % 3;

    if (hand == "Rock") 
      playerThrow = 0;
    else if (hand == "Paper")
      playerThrow = 1;
    else
      playerThrow = 2;

    if (compThrow == 0)
      computer.setText("Rock");
    else if (compThrow == 1)
      computer.setText("Paper");
    else
      computer.setText("Scissors");
       
    if (playerThrow == compThrow)
      result.setText("Tie!");
    else {
      if (playerThrow == 0) {
	if (compThrow == 1) {
	  result.setText("You lose!");
	  score.setText(String.valueOf(Integer.valueOf((score.getText()).trim()).intValue() - 1));
	} else {
	  result.setText("You win!");
	  score.setText(String.valueOf(Integer.valueOf((score.getText()).trim()).intValue() + 1));
	}
      } else if (playerThrow == 1) {
	if (compThrow == 0) {
	  result.setText("You win!");
	  score.setText(String.valueOf(Integer.valueOf((score.getText()).trim()).intValue() + 1));
	} else {
	  result.setText("You lose!");
	  score.setText(String.valueOf(Integer.valueOf((score.getText()).trim()).intValue() - 1));
	}
      } else {
	if (compThrow == 0) {
	  result.setText("You lose!");
	  score.setText(String.valueOf(Integer.valueOf((score.getText()).trim()).intValue() - 1));
	} else {
	  result.setText("You win!");
	  score.setText(String.valueOf(Integer.valueOf((score.getText()).trim()).intValue() + 1));
	}
      }
    }

   if (Integer.valueOf((score.getText()).trim()).intValue() < 0)
     score.setForeground(Color.red);
   else if (Integer.valueOf((score.getText()).trim()).intValue() > 0)
     score.setForeground(Color.green);
   else
     score.setForeground(Color.black);

  }

  public String getAppletInfo() {
    return "Rochambeaux simulator by Jamie M. Hall, 1995";
  }

}

